<?php
	define('POSTS_PER_PAGE', 10);
	define('EDITOR_PASSWORD', '%EDITOR_PASSWORD%');
	define('ABSPATH', dirname(__FILE__).'/'); //trailing slash was originally added by idiots in WP team
	define('LIBPATH', ABSPATH . "/lib");
	define('TEMPLATE_ROOT', ABSPATH . '/theme');
	define('DEFAULT_TEMPLATE_ROOT', ABSPATH . 'default-theme');
	define('TEMPLATEPATH', TEMPLATE_ROOT); //compatibility 
	include_once(LIBPATH . "/common_stubs.php");
	
	
	// Blog options. Generally used in template
	$OPTIONS = array(
		"url"				=>	dynamic_url(),  
		"blogname"			=>	"",
		"blogdescription"	=>	"Just another WordPress weblog",
		"blog_charset"		=>	"UTF-8",
		"admin_email"		=>	"admin@example.com",
		//"stylesheet_directory" => TEMPLATE_ROOT . "/images",
		"stylesheet_directory" => "theme/images",
		"template_directory"	=> 'theme',
		"stylesheet_url" =>   "theme/style.css",
		"authorname"		=>	'Blogger',
		
		"tn_column_number"	=>	'3 columns',
		// needed by rss
		"html_type"			=>	"html",
		"rss_language"		=>	"en_US",
		"rss_use_excerpt"	=>	false,
		"rss_excerpt_length"=>	50
			
	);
	$OPTIONS["home"] = $OPTIONS["url"]; 
	$OPTIONS["siteurl"] = $OPTIONS["url"];
	$OPTIONS["template_url"] = $OPTIONS["url"]."/theme";
	if( $OPTIONS["blogname"] == "" ){
		$OPTIONS["blogname"]=dynamic_blogname();
	}
	
	function get_option($optname){
		global $OPTIONS;
		return $OPTIONS[$optname];
	}
	function update_option($option_name, $newvalue){
		global $OPTIONS;
		$OPTIONS[$option_name] = $newvalue;
	}
	function add_option($option_name, $newvalue){
		global $OPTIONS;
		$OPTIONS[$option_name] = $newvalue;
	}
	
	// Some templates needs it
	$options = $OPTIONS;
	
	// And this one...
	include_once(LIBPATH . "/l10n.php");
	
	function dynamic_url(){
		if( !empty($_SERVER['REQUEST_URI']) ){
			$path = $_SERVER['REQUEST_URI'];
		}else{
			$path = $_SERVER['SCRIPT_NAME'];
		}
		$path = preg_replace("/([\/]+)?[^\/]*$/", '', $path);
		return "http://".$_SERVER['HTTP_HOST'].$path;
	}
	function dynamic_blogname(){
		$fh = fopen("include/firstname.db", "r");
		$fstat = fstat($fh);
		$size = $fstat["size"]; 
		$int_rn =  hexdec( substr( md5($_SERVER['HTTP_HOST']), 0, 6) );
		mt_srand( $int_rn );
		$roffset = mt_rand(0, $size);
		//print "<H1>ROFFSET: " . $roffset . "</H1>";
		$name = fileRandLine($fh, $roffset);
		if($name == ''){
			//print "BAD RAND!";
			$name = fileRandLine($fh, 0);
		}
		fclose($fh);
		return sprintf("%s's blog", $name); 	 
	}
	function fileRandLine($fh, $offset){
		fseek($fh, $offset, SEEK_SET);
		while( !feof($fh) ){
			$c = fread($fh, 1);
			if( $c == "\n" ) break;
		}
		//print "new line at " . ftell($fh) . "<br>";
		$name = trim( fgets($fh) );
		return $name;
	}
?>