<?php
	// Delete magick quotes
	function strip_mq($var){
		if ( get_magic_quotes_gpc() ) {
	    	if( is_array($var) ){
	    		$var = stripslashArray($var);
	    	}else{
	    		$var = stripslashes($var);
	    	}
		}
		return $var;
	}
	function stripslashArray($a){
		$keys = array_keys($a);
		for($i = 0; $i < count($a); $i++){
    		$a[$keys[$i]] = stripslashes( $a[$keys[$i]] );
		}
		return $a;
	}
	
	function time2mysql($time){
		$lt = localtime($time, true);
		$ty = $lt["tm_year"]+1900;
		$tm = $lt["tm_mon"]+1;
		$td = $lt["tm_mday"];
		return sprintf("%04d-%02d-%02d", $ty, $tm, $td);
	}
	
	function apply_filters($fname, $val){
		return $val;
	}
	
	function wp_register_sidebar_widget(){}
	function wp_register_widget_control(){}
	function add_action(){}
	function unregister_sidebar_widget(){}
	function add_filter(){}
	function get_the_guid(){}
	function the_guid( $id = 0 ) {
        echo get_the_guid($id);
	}
	function do_action(){}
	
	function make_url_footnote( $content ) {
	preg_match_all( '/<a(.+?)href=\"(.+?)\"(.*?)>(.+?)<\/a>/', $content, $matches );
	$j = 0;
	for ( $i=0; $i<count($matches[0]); $i++ ) {
		$links_summary = ( !$j ) ? "\n" : $links_summary;
		$j++;
		$link_match = $matches[0][$i];
		$link_number = '['.($i+1).']';
		$link_url = $matches[2][$i];
		$link_text = $matches[4][$i];
		$content = str_replace( $link_match, $link_text . ' ' . $link_number, $content );
		$link_url = ( ( strtolower( substr( $link_url, 0, 7 ) ) != 'http://' ) && ( strtolower( substr( $link_url, 0, 8 ) ) != 'https://' ) ) ? get_option( 'home' ) . $link_url : $link_url;
		$links_summary .= "\n" . $link_number . ' ' . $link_url;
	}
	$content  = strip_tags( $content );
	$content .= $links_summary;
	return $content;
}

function stubTest(){
	echo get_option( 'home' );
}

function convert_chars($content, $deprecated = '') {
	// Translation of invalid Unicode references range to valid range
	$wp_htmltranswinuni = array(
	'&#128;' => '&#8364;', // the Euro sign
	'&#129;' => '',
	'&#130;' => '&#8218;', // these are Windows CP1252 specific characters
	'&#131;' => '&#402;',  // they would look weird on non-Windows browsers
	'&#132;' => '&#8222;',
	'&#133;' => '&#8230;',
	'&#134;' => '&#8224;',
	'&#135;' => '&#8225;',
	'&#136;' => '&#710;',
	'&#137;' => '&#8240;',
	'&#138;' => '&#352;',
	'&#139;' => '&#8249;',
	'&#140;' => '&#338;',
	'&#141;' => '',
	'&#142;' => '&#382;',
	'&#143;' => '',
	'&#144;' => '',
	'&#145;' => '&#8216;',
	'&#146;' => '&#8217;',
	'&#147;' => '&#8220;',
	'&#148;' => '&#8221;',
	'&#149;' => '&#8226;',
	'&#150;' => '&#8211;',
	'&#151;' => '&#8212;',
	'&#152;' => '&#732;',
	'&#153;' => '&#8482;',
	'&#154;' => '&#353;',
	'&#155;' => '&#8250;',
	'&#156;' => '&#339;',
	'&#157;' => '',
	'&#158;' => '',
	'&#159;' => '&#376;'
	);
	// Remove metadata tags
	$content = preg_replace('/<title>(.+?)<\/title>/','',$content);
	$content = preg_replace('/<category>(.+?)<\/category>/','',$content);
	// Converts lone & characters into &#38; (a.k.a. &amp;)
	$content = preg_replace('/&([^#])(?![a-z1-4]{1,8};)/i', '&#038;$1', $content);
	// Fix Word pasting
	$content = strtr($content, $wp_htmltranswinuni);
	// Just a little XHTML help
	$content = str_replace('<br>', '<br />', $content);
	$content = str_replace('<hr>', '<hr />', $content);
	return $content;
}

function is_wp_error($thing) {
	if ( is_object($thing) && is_a($thing, 'WP_Error') ) return true;
	return false;
}

function format_to_edit($content, $richedit = false) {
	$content = apply_filters('format_to_edit', $content);
	if (! $richedit )
		$content = htmlspecialchars($content);
	return $content;
}

	
/*
 * A class for displaying various tree-like structures.
 * Extend the Walker class to use it, see examples at the bottom
 */
class Walker {
	var $tree_type;
	var $db_fields;

	//abstract callbacks
	function start_lvl($output) { return $output; }
	function end_lvl($output)   { return $output; }
	function start_el($output)  { return $output; }
	function end_el($output)    { return $output; }

	/*
 	 * display one element if the element doesn't have any children
 	 * otherwise, display the element and its children
 	 */
	function display_element( $element, &$children_elements, $max_depth, $depth=0, $args, $output ) {

		if ( !$element)
			return $output;

		$id_field = $this->db_fields['id'];
		$parent_field = $this->db_fields['parent'];

		//display this element
		$cb_args = array_merge( array($output, $element, $depth), $args);
		$output = call_user_func_array(array(&$this, 'start_el'), $cb_args);

		if ( $max_depth == 0 ||
		     ($max_depth != 0 &&  $max_depth > $depth+1 )) { //whether to descend

			for ( $i = 0; $i < sizeof( $children_elements ); $i++ ) {

				$child = $children_elements[$i];
				if ( $child->$parent_field == $element->$id_field ) {

					if ( !isset($newlevel) ) {
						$newlevel = true;
						//start the child delimiter
						$cb_args = array_merge( array($output, $depth), $args);
						$output = call_user_func_array(array(&$this, 'start_lvl'), $cb_args);
					}

					array_splice( $children_elements, $i, 1 );
					$output = $this->display_element( $child, $children_elements, $max_depth, $depth + 1, $args, $output );
					$i = -1;
				}
			}
		}

		if ( isset($newlevel) && $newlevel ){
			//end the child delimiter
			$cb_args = array_merge( array($output, $depth), $args);
			$output = call_user_func_array(array(&$this, 'end_lvl'), $cb_args);
		}

		//end this element
		$cb_args = array_merge( array($output, $element, $depth), $args);
		$output = call_user_func_array(array(&$this, 'end_el'), $cb_args);

		return $output;
	}

	/*
 	* displays array of elements hierarchically
 	* it is a generic function which does not assume any existing order of elements
 	* max_depth = -1 means flatly display every element
 	* max_depth = 0  means display all levels
 	* max_depth > 0  specifies the number of display levels.
 	*/
	function walk( $elements, $max_depth) {

		$args = array_slice(func_get_args(), 2);
		$output = '';

		if ($max_depth < -1) //invalid parameter
			return $output;

		if (empty($elements)) //nothing to walk
			return $output;

		$id_field = $this->db_fields['id'];
		$parent_field = $this->db_fields['parent'];

		// flat display
		if ( -1 == $max_depth ) {
			$empty_array = array();
			foreach ( $elements as $e )
				$output = $this->display_element( $e, $empty_array, 1, 0, $args, $output );
			return $output;
		}

		/*
		 * need to display in hierarchical order
		 * splice elements into two buckets: those without parent and those with parent
		 */
		$top_level_elements = array();
		$children_elements  = array();
		foreach ( $elements as $e) {
			if ( 0 == $e->$parent_field )
				$top_level_elements[] = $e;
			else
				$children_elements[] = $e;
		}

		/*
		 * none of the elements is top level
		 * the first one must be root of the sub elements
		 */
		if ( !$top_level_elements ) {

			$root = $children_elements[0];
			for ( $i = 0; $i < sizeof( $children_elements ); $i++ ) {

				$child = $children_elements[$i];
				if ($root->$parent_field == $child->$parent_field ) {
					$top_level_elements[] = $child;
					array_splice( $children_elements, $i, 1 );
					$i--;
				}
			}
		}

		foreach ( $top_level_elements as $e )
			$output = $this->display_element( $e, $children_elements, $max_depth, 0, $args, $output );

		/*
		* if we are displaying all levels, and remaining children_elements is not empty,
		* then we got orphans, which should be displayed regardless
	 	*/
		if ( ( $max_depth == 0 ) && sizeof( $children_elements ) > 0 ) {
			$empty_array = array();
			foreach ( $children_elements as $orphan_e )
				$output = $this->display_element( $orphan_e, $empty_array, 1, 0, $args, $output );
		 }
		 return $output;
	}
}
?>