<?php
	
	$db_db_fname = "db/entry.bin";
	$db_lock_fname = "db/locker";
	$db_entry_list_fname = "db/entry_list.bin";
	$db_category_root_dir = "db/category";
	
		
	// Adding new entry
    function addEntry ($category, $title, $text){
		if( !file_exists( $GLOBALS["db_db_fname"] ) ){
			// hmm... I'd like sysopen here, but it seems to be unsupported.
			fclose(fopen($GLOBALS["db_db_fname"], "w"));
		}
		$locker = _getLock();
		
		$fh = fopen($GLOBALS["db_db_fname"], "r+");
		fseek($fh, 0, SEEK_END);
		$cur_offset = ftell($fh);
		
		$id = getEntryCount()+1;
		
		// Calculating entry len
		$title_len = length($title);
		$text_len = length($text);
				
		if(!is_array($category)){
			$category = array(0 => $category);
		}
		
		$category_string = implode("\x0", $category);
		$cat_len = length($category_string);
		
		$elen = 20+$title_len+$text_len+$cat_len;
		// Binary packet
		
		$packet = 
			pack("I", $elen).
			pack("I", $title_len).
			pack("I", $cat_len).
			pack("I", time()).
			pack("I", $id).
			$title.
			$category_string.
			$text;
		fwrite($fh, $packet);				
		
		// Add to global entry listing
		_addToEntryList( $cur_offset );
		// Add to category entry listing
		_addToCategory($category, $cur_offset);
		// Let them go for now.
		_releaseLock($locker);
		return $id;			
    }
	
	/*
	 * This func takes num offset param
	 * Return array of Entry objects
	 */
	function getEntrySeqReverse($r_offset, $limit){
		//First of all let's get right offset and limit
		$elist_fh = _open_dbfile( $GLOBALS["db_entry_list_fname"] );
		$fstat = fstat($elist_fh);
		$ecount = $fstat["size"]/4;
		if( ($ecount - $r_offset) <= 0 ){
			return array();
		}elseif( ($ecount - $r_offset) < $limit ){
			$limit = $ecount - $r_offset;
		}
		/*
		print "We have " . $ecount . " entries at all<br>";
		print "Elist size: " . $fstat["size"] . " bytes<br>";
		print "we need to start from " . ($ecount-($r_offset+$limit)) . "element<br>";
		*/
		
		//$first_entry_id = ($ecount-($r_offset+$limit))+1;
		$elist_offset = ($ecount-($r_offset+$limit))*4;
		//print "Elist offset: " . $elist_offset . "<br>"; 
		
		fseek($elist_fh, $elist_offset, SEEK_SET);
		
		//print "Entrylist Pointer set to " . ftell($elist_fh) . "<br>";
		
		$first_entry_offset = _unpack("I", fread($elist_fh, 4));
		
		//print "Entry base offset: " . $first_entry_offset . "<br>"; 
		
		fclose($elist_fh);
		// Done, now it's piece of cake (c. Duke Nukem 3D)
		$entry_list = _getEntrySeq($first_entry_offset, $limit);
		return array_reverse($entry_list);
	}
	
	function getCategoryEntrySeqReverse($r_offset, $limit, $cat_name){
		$cat_file = $GLOBALS["db_category_root_dir"] . "/" . md5(_normalizeCategoryName($cat_name)) . ".bin";
		if(! file_exists($cat_file)){
			return array();
		}
				
		//First of all let's get right offset and limit
		$elist_fh = _open_dbfile( $cat_file );
		$fstat = fstat($elist_fh);
		$ecount = $fstat["size"]/4;
		if( ($ecount - $r_offset) <= 0 ){
			return array();
		}elseif( ($ecount - $r_offset) < $limit ){
			$limit = $ecount - $r_offset;
		}
		/*
		print "We have " . $ecount . " entries at all<br>";
		print "Elist size: " . $fstat["size"] . " bytes<br>";
		print "we need to start from " . ($ecount-($r_offset+$limit)) . "element<br>";
		*/
		
		//$first_entry_id = ($ecount-($r_offset+$limit))+1;
		//print "Elist offset: " . $elist_offset . "<br>";
		$elist_offset = ($ecount-($r_offset+$limit))*4;
		fseek($elist_fh, $elist_offset, SEEK_SET);
		
		//We need to collect entry offsets
		$entry_list = array();
		for($i = 0; $i < $limit; $i++){
			if (feof($elist_fh)) break;
			$entry_offset = _unpack("I", fread($elist_fh, 4));
			$entry = _getEntrySeq($entry_offset, 1);
			if(!is_null($entry) && count($entry)>0){
				array_push($entry_list, array_shift($entry));
			}
		}
		fclose($elist_fh);
		// Done, now it's piece of cake (c. Duke Nukem 3D)
		return array_reverse($entry_list);
	}
		
	function get_list_categories(){
		// Retrieving all pussy cats :)
		$allcat_name_list = array();
		$allcat_fname = $GLOBALS["db_category_root_dir"] . "/" . "allcats.txt";
		if(file_exists($allcat_fname)){
			$allcat_fh = fopen($allcat_fname, "r");
			while ( !feof($allcat_fh) ){
				$temp_red = trim(fgets($allcat_fh));
				if($temp_red == '') continue;
				array_push($allcat_name_list, $temp_red);
			}
			fclose($allcat_fh);
		}
		return $allcat_name_list;
	}
	
	function getEntryCount(){
		$fh = _open_dbfile($GLOBALS["db_entry_list_fname"]);
		$fstat = fstat($fh);
		$ecount = $fstat["size"]/4;
		fclose($fh);
		return $ecount; 
	}
	
	function getCategoryEntryCount($cat_name){
		$cat_file = $GLOBALS["db_category_root_dir"] . "/" . md5(_normalizeCategoryName($cat_name)) . ".bin";
		if(! file_exists($cat_file)){
			return 0;
		}
		
		$fh = _open_dbfile( $cat_file );
		$fstat = fstat($fh);
		$ecount = $fstat["size"]/4;
		fclose($fh);
		return $ecount;
	}
	
	function getEntryById($id=0){
		if ($id == 0) return array();
		$offset = _getEntryOffsetById($id);
		// Out-of range
		if(is_null($offset)) return null;
		
		return _getEntrySeq($offset, 1);
	}
	
	/*
	 * Internal functions
	 */
	
	function _getEntryOffsetById($id){
		$elist_fh = _open_dbfile( $GLOBALS["db_entry_list_fname"] );
		$elist_offset = ($id-1)*4;
		// Out of range check
		$fstat = fstat($elist_fh);
		$elist_size = $fstat["size"];
		if($elist_offset >= $elist_size) {
			fclose($elist_fh);
			return null;
		}
				
		fseek($elist_fh, $elist_offset, SEEK_SET);
		$entry_offset =  _unpack("I", fread($elist_fh, 4));
		fclose($elist_fh);
		return $entry_offset;
	}
	
	/*
	 * It takes BYTE offset param
	 */
	function _getEntrySeq($offset, $ecnt){
		$elist = array();
		if( !file_exists( $GLOBALS["db_db_fname"] ) ){
			return null;
		}
		$fh = fopen($GLOBALS["db_db_fname"], "r+");
		fseek($fh, $offset, SEEK_SET);
		while($ecnt-- && !feof($fh)){
			$entry = _readEntry($fh);
			if(! is_null($entry) ){ // If it's not an object then it's null.
				array_push($elist, $entry);
			}
		}
		fclose($fh);
		return $elist;
	}
	
	function _readEntry($fh){
		// We'll need this later
		$offset = ftell($fh);
		// Header = 16 bytes
		$elen = _unpack("I", fread($fh, 4) );
		$title_len = _unpack("I", fread($fh, 4) );
		$cat_len = _unpack("I", fread($fh, 4) );
		$timestamp = _unpack("I", fread($fh, 4) );
		$id = _unpack("I", fread($fh, 4) );
		
		/*
		echo "whole entry len = " . $elen . "<br>";
		echo "header red: ";
		echo ftell($fh);
		echo "<br>";
		*/
		
		// We know len of title and category
		if($title_len > 0){
			$title = fread($fh, $title_len);
		}else{
			$title = ' ';
		}
		
		/*
		echo "title red: ";
		echo ftell($fh);
		echo "<br>";
		*/
		if($cat_len > 0){	
			$category_string = fread($fh, $cat_len);
		}else{
			$category_string = '';
		}
		
		/*
		echo "cats red: ";
		echo ftell($fh);
		echo "<br>";
		echo "cats are: " . $category_string . "<br>";
		*/
		
		// We can calculate the len of entry text
		$text_len = $elen-(20+$title_len+$cat_len);
		//echo "text len is " . $text_len . "<br>"; 
		
		if($text_len > 0){
			$text = fread($fh, $text_len);
		}else{
			$text = ' ';
		}
		
		return new Entry($elen, $offset, $id, $timestamp, $title, $text, explode("\x0", $category_string));
	}
	
//	function getEntry($offset){
//		if( !file_exists( $GLOBALS["db_db_fname"] ) ){
//			return null;
//		}
//		$fh = fopen($GLOBALS["db_db_fname"], "r+");
//				
//	}
	
	function _addToEntryList($pos){
		//print("Writing pos " . $pos . " to entry list<br>");
		//db_entry_list_fname
		if( !file_exists( $GLOBALS["db_entry_list_fname"] ) ){
			$fh = fopen( $GLOBALS["db_entry_list_fname"], "w+" );
		}else{
			$fh = fopen( $GLOBALS["db_entry_list_fname"], "r+" );
		}
		fseek($fh, 0, SEEK_END);
		fwrite($fh, pack("I", $pos));
		fclose($fh);
	}
	
	function _addToCategory($cat_list, $pos){
		if(!file_exists($GLOBALS["db_category_root_dir"])){
			mkdir( $GLOBALS["db_category_root_dir"] );
		}
		
		// Retrieving all pussy cats :)
		$allcat_name_list = array();
		$allcat_fname = $GLOBALS["db_category_root_dir"] . "/" . "allcats.txt";
		if(file_exists($allcat_fname)){
			$allcat_fh = fopen($allcat_fname, "r");
			while ( !feof($allcat_fh) ){
				$temp_red = trim(fgets($allcat_fh));
				if($temp_red == '') continue;
				array_push($allcat_name_list, $temp_red);
			}
			fclose($allcat_fh);
		}
		
		/*
		print "-----<br>";
		for($i = 0; $i < length($allcat_name_list); $i++){
			print("cat|".$allcat_name_list[$i]."|<br>");
		}
		*/
						
		for($i = 0; $i < count($cat_list); $i++){
			$cat_name = _normalizeCategoryName($cat_list[$i]);
			array_push($allcat_name_list, $cat_name);
			
			$cat_fname = $GLOBALS["db_category_root_dir"] . "/" . md5($cat_name) . ".bin";
			if(!file_exists($cat_fname)){
				$cat_fh = fopen($cat_fname, "w+");
			}else{
				$cat_fh = fopen($cat_fname, "r+");
			}
			fseek($cat_fh, 0, SEEK_END);
			fwrite($cat_fh, pack("I", $pos));
			fclose($cat_fh);
		}
						
		// Uniq cats list and write it back to the file
		$allcat_name_list = array_values( array_unique($allcat_name_list) );
				
		$allcat_fh = fopen($allcat_fname, "w");
		for($i = 0; $i < length($allcat_name_list); $i++){
			fwrite($allcat_fh, $allcat_name_list[$i]."\n");
		}
		fclose($allcat_fh);
	}
	function _normalizeCategoryName($name){
		return strtolower(trim($name));
	}
	
	// Locker
	function _getLock(){
		if( !file_exists($GLOBALS["db_lock_fname"]) ){
			// hmm... I'd like sysopen here, but it seems to be unsupported.
			fclose(fopen($GLOBALS["db_lock_fname"], "w"));
		}
		$fh = fopen( $GLOBALS["db_lock_fname"], "r+" );
		if(flock($fh, LOCK_EX)){
			return $fh;
		}
	}
	function _releaseLock($fh){
		flock($fh, LOCK_UN);
		fclose($fh);
	}
	
	// I'm fucking idiot, but I can't believe there is no length function built in 8)
	// I don't want to refactor it all after I've used length() for a dozen of times, so I'd better define it myself :)
	function length($v){
		if(is_array($v)){
			return count($v);
		}else{
			return strlen($v);
		}
	}
	
	// unpack() works slightly different from Perl. We'll make it works as it have to.
	function _unpack($pattern, $data){
		$a = unpack($pattern, $data);
		return $a["1"];
	}
	
	function _open_dbfile($fname){
		if( !file_exists( $fname ) ){
			$fh = fopen( $fname, "w+" );
		}else{
			$fh = fopen( $fname, "r+" );
		}
		return $fh;
	}
	
	function getEntryBaseLastModified(){
		$fh = _open_dbfile($GLOBALS["db_db_fname"]);
		$fstat = fstat($fh);
		$mtime = $fstat["mtime"];
		$time_a = localtime($mtime, true);
		$ty = $time_a["tm_year"]+1900;
		$tm = $time_a["tm_mon"]+1;
		$td = $time_a["tm_mday"];
		return sprintf("%04d-%02d-%02d", $ty, $tm, $td); 
	}
	
	/*
	 * Classes defined here
	 */
	
	class Entry {
    	var $elen;
		var $offset;
		var $timestamp;
		var $title;
		var $text;
		var $category;
		var $id;
				
		// WP-compat
		var $post_date;
		var $post_content;
		var $post_title;
		var $post_password;
		var $post_modified_gmt;
		var $post_modified;
		
		function Entry($elen, $offset, $id, $timestamp, $title, $text, $category){
			$this->elen = $elen;
			$this->offset = $offset;
			$this->title = $title;
			$this->text = $text;
			$this->category = $category;
			$this->timestamp = $timestamp;
			$this->id = $id;
			
			// WP-compat
			$this->post_date = $timestamp;
			$this->post_content = $this->text;
			$this->post_title = $this->title;
			$this->post_modified_gmt = time2mysql($timestamp);
			$this->post_modified = time2mysql($timestamp);
		}
		
		function id(){
			return $this->id;
		}
    }
?>