<?php
	
	// For some themes with multiple color profiles.
	$wppt_color_scheme = 'red';
	// This is for themes which require direct DB access.
	$wpdb = new Wpdb();
	//Some themes have this file inside
	//And it seems that we have to include it 
	load_template("functions.php");	
		
	/*
	 * Let's add some function stubs
	 */	
		
	function bloginfo($show='') {
		echo get_bloginfo($show, 'display');
	}
	function get_bloginfo($show = '', $filter = 'raw') {
		switch($show) {
			case 'url' :
			case 'home' : // DEPRECATED
			case 'siteurl' : // DEPRECATED
				$output = get_option('url');
				break;
			case 'url':
				$output = get_option('url');
				break;
			case 'wpurl' :
				$output = get_option('url');
				break;
			case 'description':
				$output = get_option('blogdescription');
				break;
			case 'admin_email':
				$output = get_option('admin_email');
				break;
			case 'charset':
				$output = get_option('blog_charset');
				if ('' == $output) $output = 'UTF-8';
				break;
			case 'html_type' :
				$output = get_option('html_type');
				break;
			case 'version':
				$output = "";
				break;
			case 'stylesheet_url':
				$output = get_option('stylesheet_url');
				break;
			case 'template_directory':
				$output = get_option('template_directory');
				break;
			case 'template_url':
				$output = get_option('template_url');	
				break;
			case 'rss_url':
				$output = get_feed_link('rss');
				break;
			case 'rss2_url':
				$output = get_feed_link('rss2');
				break;
			case 'atom_url':
				$output = get_feed_link('atom');
				break;
			default:
				$output = get_option('blogname');
				break;
		}
		return $output;
	}
	
	function is_home(){
		global $CUR_VIEW;
		$is_home;
		switch($CUR_VIEW){
			case 'index':
				$is_home = true;
				break;
			default:
				$is_home = false;
				break;
		}
		return $is_home;
	}
	
	function get_header(){
		load_template("/header.php");
	}
	
	function load_template($tfile){
		global $post, $wppt_color_scheme, $wpdb;
		if( file_exists($tfile) ){
			include_once($tfile);
		}else{
			if( substr($tfile, 0, 1) != "/"){
				$tfile = "/" . $tfile;
			}
			$fp = TEMPLATE_ROOT . $tfile;
			if(file_exists( $fp )) include_once($fp);
		}
	}
	
	function wp_list_pages(){
		$fname = 'include/list_pages.php';
		if(file_exists($fname))	include_once($fname);
	}
	
	function wp_head() {
		//do_action('wp_head');
	}
	/*
	 * is_* default funcs here
	 */
	function is_page(){
		return false;
	}
	function is_category(){
		global $CUR_VIEW;
		$out;
		switch($CUR_VIEW){
			case 'category':
				$out=true;
				break;
			default:
				$out=false;
				break;
		}
		return $out;
	}
	function is_single(){
		global $CUR_VIEW;
		$out;
		switch($CUR_VIEW){
			case 'post':
				$out=true;
				break;
			default:
				$out=false;
				break;
		}
		return $out;
	}
	function is_front_page(){
		return false;
	}
	function is_date(){
		return false;
	}
	function is_tag(){
		return false;
	}
	function is_search(){
		return false;
	}
	function is_author(){
		return false;
	}
	function is_404(){
		return false;
	}
	function is_attachment(){
		return false;
	}
	function is_archive(){
		return false;
	}
	function is_paged(){
		return false;
	}
	function is_singular(){
		return is_single();
	}
	function is_month(){
		return false;
	}
	function is_day(){
		return false;
	}
	function is_year(){
		return false;
	}
	function is_page_template(){
		return false;
	}
	
	function language_attributes($doctype = 'html') {
        $attributes = array();
        $output = '';
        echo $output;
	}
	
	function get_template_directory(){
		return TEMPLATE_ROOT;
	}
	
	function the_post(){
		global $entry_list, $post;
		
		if(is_null($entry_list))return false;  
		if(count($entry_list) == 0) return false;
		$a_post = array_shift($entry_list);
		
		$post = $a_post;
		return true;	
	}
	function get_post($id = 0){
		global $post;
		return $post;
	}
	
	function get_posts(){
		return getEntrySeqReverse(0, 10);
	}
	
	function the_title($before = '', $after = '', $echo = true) {
        $title = get_the_title();
        if ( strlen($title) == 0 )
                return;
        $title = $before . $title . $after;
        if ( $echo )
                echo $title;
        else
                return $title;
	}
	function get_the_title($id = 0){
		$post = get_post($id);
		return $post->title;
	}
	
	function the_excerpt(){
		return get_the_excerpt();
	}
	function get_the_excerpt(){
		return "";
	}
	
	
	function get_footer() {
		if ( file_exists( TEMPLATEPATH . '/footer.php') )
			load_template( TEMPLATEPATH . '/footer.php');
        else
			load_template( ABSPATH . 'default-theme/footer.php');
	}

	
	// those two make permalinks of posts
	function the_permalink(){
		echo get_permalink();
	}
	function get_permalink($post=null){
		if(is_null($post)){
			$post = get_post();
		}
		$url = get_option('url');
		return $url."/?view=post&bin_offset=".$post->offset."&id=".$post->id;
	}
	
	function have_posts(){
		global $entry_list;
		if(is_null($entry_list))return false;  
		if(count($entry_list) == 0) return false;
		return true; 
	}
	
	
	function get_themes() {
		global $wp_themes, $wp_broken_themes;
	
		if ( isset($wp_themes) )
			return $wp_themes;
	
		$themes = array();
		$wp_broken_themes = array();
		$theme_loc = $theme_root = get_theme_root();
		if ( '/' != ABSPATH ) // don't want to replace all forward slashes, see Trac #4541
			$theme_loc = str_replace(ABSPATH, '', $theme_root);
	
		// Files in wp-content/themes directory and one subdir down
		$themes_dir = @ opendir($theme_root);
		if ( !$themes_dir )
			return false;
	
		while ( ($theme_dir = readdir($themes_dir)) !== false ) {
			if ( is_dir($theme_root . '/' . $theme_dir) && is_readable($theme_root . '/' . $theme_dir) ) {
				if ( $theme_dir{0} == '.' || $theme_dir == '..' || $theme_dir == 'CVS' )
					continue;
				$stylish_dir = @ opendir($theme_root . '/' . $theme_dir);
				$found_stylesheet = false;
				while ( ($theme_file = readdir($stylish_dir)) !== false ) {
					if ( $theme_file == 'style.css' ) {
						$theme_files[] = $theme_dir . '/' . $theme_file;
						$found_stylesheet = true;
						break;
					}
				}
				@closedir($stylish_dir);
				if ( !$found_stylesheet ) { // look for themes in that dir
					$subdir = "$theme_root/$theme_dir";
					$subdir_name = $theme_dir;
					$theme_subdir = @ opendir( $subdir );
					while ( ($theme_dir = readdir($theme_subdir)) !== false ) {
						if ( is_dir( $subdir . '/' . $theme_dir) && is_readable($subdir . '/' . $theme_dir) ) {
							if ( $theme_dir{0} == '.' || $theme_dir == '..' || $theme_dir == 'CVS' )
								continue;
							$stylish_dir = @ opendir($subdir . '/' . $theme_dir);
							$found_stylesheet = false;
							while ( ($theme_file = readdir($stylish_dir)) !== false ) {
								if ( $theme_file == 'style.css' ) {
									$theme_files[] = $subdir_name . '/' . $theme_dir . '/' . $theme_file;
									$found_stylesheet = true;
									break;
								}
							}
							@closedir($stylish_dir);
						}
					}
					@closedir($theme_subdir);
					$wp_broken_themes[$theme_dir] = array('Name' => $theme_dir, 'Title' => $theme_dir, 'Description' => __('Stylesheet is missing.'));
				}
			}
		}
		if ( is_dir( $theme_dir ) )
			@closedir( $theme_dir );
	
		if ( !$themes_dir || !$theme_files )
			return $themes;
	
		sort($theme_files);
	
		foreach ( (array) $theme_files as $theme_file ) {
			if ( !is_readable("$theme_root/$theme_file") ) {
				$wp_broken_themes[$theme_file] = array('Name' => $theme_file, 'Title' => $theme_file, 'Description' => __('File not readable.'));
				continue;
			}
	
			$theme_data = get_theme_data("$theme_root/$theme_file");
	
			$name        = $theme_data['Name'];
			$title       = $theme_data['Title'];
			$description = wptexturize($theme_data['Description']);
			$version     = $theme_data['Version'];
			$author      = $theme_data['Author'];
			$template    = $theme_data['Template'];
			$stylesheet  = dirname($theme_file);
	
			$screenshot = false;
			foreach ( array('png', 'gif', 'jpg', 'jpeg') as $ext ) {
				if (file_exists("$theme_root/$stylesheet/screenshot.$ext")) {
					$screenshot = "screenshot.$ext";
					break;
				}
			}
	
			if ( empty($name) ) {
				$name = dirname($theme_file);
				$title = $name;
			}
	
			if ( empty($template) ) {
				if ( file_exists(dirname("$theme_root/$theme_file/index.php")) )
					$template = dirname($theme_file);
				else
					continue;
			}
	
			$template = trim($template);
	
			if ( !file_exists("$theme_root/$template/index.php") ) {
				$parent_dir = dirname(dirname($theme_file));
				if ( file_exists("$theme_root/$parent_dir/$template/index.php") ) {
					$template = "$parent_dir/$template";
				} else {
					$wp_broken_themes[$name] = array('Name' => $name, 'Title' => $title, 'Description' => __('Template is missing.'));
					continue;
				}
			}
	
			$stylesheet_files = array();
			$stylesheet_dir = @ dir("$theme_root/$stylesheet");
			if ( $stylesheet_dir ) {
				while ( ($file = $stylesheet_dir->read()) !== false ) {
					if ( !preg_match('|^\.+$|', $file) && preg_match('|\.css$|', $file) )
						$stylesheet_files[] = "$theme_loc/$stylesheet/$file";
				}
			}
	
			$template_files = array();
			$template_dir = @ dir("$theme_root/$template");
			if ( $template_dir ) {
				while(($file = $template_dir->read()) !== false) {
					if ( !preg_match('|^\.+$|', $file) && preg_match('|\.php$|', $file) )
						$template_files[] = "$theme_loc/$template/$file";
				}
			}
	
			$template_dir = dirname($template_files[0]);
			$stylesheet_dir = dirname($stylesheet_files[0]);
	
			if ( empty($template_dir) )
				$template_dir = '/';
			if ( empty($stylesheet_dir) )
				$stylesheet_dir = '/';
	
			// Check for theme name collision.  This occurs if a theme is copied to
			// a new theme directory and the theme header is not updated.  Whichever
			// theme is first keeps the name.  Subsequent themes get a suffix applied.
			// The Default and Classic themes always trump their pretenders.
			if ( isset($themes[$name]) ) {
				if ( ('WordPress Default' == $name || 'WordPress Classic' == $name) &&
						 ('default' == $stylesheet || 'classic' == $stylesheet) ) {
					// If another theme has claimed to be one of our default themes, move
					// them aside.
					$suffix = $themes[$name]['Stylesheet'];
					$new_name = "$name/$suffix";
					$themes[$new_name] = $themes[$name];
					$themes[$new_name]['Name'] = $new_name;
				} else {
					$name = "$name/$stylesheet";
				}
			}
	
			$themes[$name] = array('Name' => $name, 'Title' => $title, 'Description' => $description, 'Author' => $author, 'Version' => $version, 'Template' => $template, 'Stylesheet' => $stylesheet, 'Template Files' => $template_files, 'Stylesheet Files' => $stylesheet_files, 'Template Dir' => $template_dir, 'Stylesheet Dir' => $stylesheet_dir, 'Status' => $theme_data['Status'], 'Screenshot' => $screenshot, 'Tags' => $theme_data['Tags']);
		}
	
		// Resolve theme dependencies.
		$theme_names = array_keys($themes);
	
		foreach ( (array) $theme_names as $theme_name ) {
			$themes[$theme_name]['Parent Theme'] = '';
			if ( $themes[$theme_name]['Stylesheet'] != $themes[$theme_name]['Template'] ) {
				foreach ( (array) $theme_names as $parent_theme_name ) {
					if ( ($themes[$parent_theme_name]['Stylesheet'] == $themes[$parent_theme_name]['Template']) && ($themes[$parent_theme_name]['Template'] == $themes[$theme_name]['Template']) ) {
						$themes[$theme_name]['Parent Theme'] = $themes[$parent_theme_name]['Name'];
						break;
					}
				}
			}
		}
	
		$wp_themes = $themes;
	
		return $themes;
	}
	function get_theme_root(){
		return TEMPLATE_ROOT;
	}
	function get_theme($theme) {
		$themes = get_themes();
	
		if ( array_key_exists($theme, $themes) )
			return $themes[$theme];
	
		return NULL;
	}
	
	function wp_title($sep = '&raquo;', $display = true, $seplocation = '') {
		global $post, $entry_list;
		$title = '';
		
		if( is_category() ){
			$title = $cur_category;
		}
		if( is_single() ){
			if( is_null($post) ){
				if(count($entry_list) > 0){
					$title = $entry_list[0]->post_title;
				}
			}else{
				$title = $post->post_title;
			}
		}
		
		$prefix = '';
        if ( !empty($title) ) $prefix = " $sep ";
        // Determines position of the separator
        if ( 'right' == $seplocation ){
                $title = $title . $prefix;
        }else{
                $title = $prefix . $title;
		}
        $title = apply_filters('wp_title', $title, $sep);
        // Send it out
        if ( $display )
			echo $title;
        else
			return $title;
	}
	
	function wp_get_archives(){
		return "theme_adapter:wp_get_archives";
	}
	// deprecated call
	function get_archives($type='', $limit='', $format='html', $before = '', $after = '', $show_post_count = false) {
        $args = compact('type', 'limit', 'format', 'before', 'after', 'show_post_count');
        return wp_get_archives($args);
	}
	function get_archives_link($url, $text, $format = 'html', $before = '', $after = '') {
        if ('link' == $format)
                return "\t<link rel='archives' title='$title_text' href='$url' />\n";
        elseif ('option' == $format)
                return "\t<option value='$url'>$before $text $after</option>\n";
        elseif ('html' == $format)
                return "\t<li>$before<a href='$url' title='$title_text'>$text</a>$after</li>\n";
        else // custom
                return "\t$before<a href='$url' title='$title_text'>$text</a>$after\n";
	}
		
	function get_the_time( $d = '' ) {
		$the_time = get_post_time($d);
		return $the_time;
	}
	function get_post_time( $d = 'U') { // returns timestamp
        global $post;
		$time = $post->timestamp;
		
		$time_array = localtime($time, true);
		$ty = $time_array["tm_year"]+1900; 
		$tm = $time_array["tm_mon"]+1;
		$td = $time_array["tm_mday"];
		
		$mysql_date_string = sprintf("%04d-%02d-%02d", $ty, $tm, $td);
		//echo "<br>Mysql Date string=".$mysql_date_string; 
		
		$out = mysql2date($d, $mysql_date_string);
		//echo "<br> type: " . $d. " out=".$out;
		
		return $out; 
		
		/*
		$out = '';
		switch($d){
			case 'M':
				$out = $time_array["tm_mon"]+1;
				break;
			case 'Y':
				$out = $time_array["tm_year"]+1900;
				break;
			default:
				$out = $y."-".$m."-".$d;
				break;
		}
		*/
		
	}
	function the_time( $d = '' ) {
        echo get_the_time($d);
	}
	
	function the_tags(){}

	function mysql2date( $dateformatstring, $mysqlstring, $translate = false ) {
        global $wp_locale;
        $m = $mysqlstring;
        if ( empty( $m ) )
                return false;

        if( 'G' == $dateformatstring ) {
                return gmmktime(
                        (int) substr( $m, 11, 2 ), (int) substr( $m, 14, 2 ), (int) substr( $m, 17, 2 ),
                        (int) substr( $m, 5, 2 ), (int) substr( $m, 8, 2 ), (int) substr( $m, 0, 4 )
                );
        }

        $i = mktime(
                (int) substr( $m, 11, 2 ), (int) substr( $m, 14, 2 ), (int) substr( $m, 17, 2 ),
                (int) substr( $m, 5, 2 ), (int) substr( $m, 8, 2 ), (int) substr( $m, 0, 4 )
        );

        if( 'U' == $dateformatstring )
                return $i;

        if ( -1 == $i || false == $i )
                $i = 0;

        if ( !empty( $wp_locale->month ) && !empty( $wp_locale->weekday ) && $translate ) {
                $datemonth = $wp_locale->get_month( date( 'm', $i ) );
                $datemonth_abbrev = $wp_locale->get_month_abbrev( $datemonth );
                $dateweekday = $wp_locale->get_weekday( date( 'w', $i ) );
                $dateweekday_abbrev = $wp_locale->get_weekday_abbrev( $dateweekday );
                $datemeridiem = $wp_locale->get_meridiem( date( 'a', $i ) );
                $datemeridiem_capital = $wp_locale->get_meridiem( date( 'A', $i ) );
                $dateformatstring = ' ' . $dateformatstring;
                $dateformatstring = preg_replace( "/([^\\\])D/", "\\1" . backslashit( $dateweekday_abbrev ), $dateformatstring );
                $dateformatstring = preg_replace( "/([^\\\])F/", "\\1" . backslashit( $datemonth ), $dateformatstring );
                $dateformatstring = preg_replace( "/([^\\\])l/", "\\1" . backslashit( $dateweekday ), $dateformatstring );
                $dateformatstring = preg_replace( "/([^\\\])M/", "\\1" . backslashit( $datemonth_abbrev ), $dateformatstring );
                $dateformatstring = preg_replace( "/([^\\\])a/", "\\1" . backslashit( $datemeridiem ), $dateformatstring );
                $dateformatstring = preg_replace( "/([^\\\])A/", "\\1" . backslashit( $datemeridiem_capital ), $dateformatstring );

                $dateformatstring = substr( $dateformatstring, 1, strlen( $dateformatstring ) -1 );
        }
        $j = @date( $dateformatstring, $i );

        /*
        if ( !$j ) // for debug purposes
                echo $i." ".$mysqlstring;
        */

        return $j;
	}
	
	function get_trackback_url(){
		$url = get_option('url');
		return $url . "/trackback.php";
	}
	
	function trackback_url($deprecated = true) {
        if ($deprecated) echo get_trackback_url();
        else return get_trackback_url();
	}

	/**
	 * trackback_rdf() - Generates and displays the RDF for the trackback information of current post
	 *
	 * @since 0.71
	 *
	 * @param int $deprecated Not used (Was $timezone = 0)
	 */
	function trackback_rdf($deprecated = '') {
	        if (strpos(strtolower($_SERVER['HTTP_USER_AGENT']), strtolower('W3C_Validator')) === false) {
	                echo '<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
	                                xmlns:dc="http://purl.org/dc/elements/1.1/"
	                                xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/">
	                        <rdf:Description rdf:about="';
	                the_permalink();
	                echo '"'."\n";
	                echo '    dc:identifier="';
	                the_permalink();
	                echo '"'."\n";
	                echo '    dc:title="'.str_replace('--', '&#x2d;&#x2d;', wptexturize(strip_tags(get_the_title()))).'"'."\n";
	                echo '    trackback:ping="'.get_trackback_url().'"'." />\n";
	                echo '</rdf:RDF>';
	        }
	}
	
	function wptexturize($text) {
    	return $text;
	}
	
	function get_the_content(){
		global $post;
		$output = $post->post_content;
		return $output; 
	}
	function the_content($more_link_text = '(more...)', $stripteaser = 0, $more_file = '') {
        $content = get_the_content($more_link_text, $stripteaser, $more_file);
        $content = apply_filters('the_content', $content);
        $content = str_replace(']]>', ']]&gt;', $content);
        echo $content;
	}
	function get_comments_link(){
		return get_permalink() . '#comments';
	}
	function comments_link( $deprecated = '', $deprecated = '' ) {
        echo get_comments_link();
	}
	function get_comments_number(){
		return 0;
	}
	function comments_number(){
		echo get_comments_number();
	}
	function post_comments_feed_link(){}
	
	function get_the_category_list($separator = ' ', $parents = ' ', $post_id = 0){
		global $post;
		$cat_list = $post->category;
		return implode($separator, $cat_list);
	}
	function the_category($separator = '', $parents='', $post_id = false) {
		echo get_the_category_list($separator, $parents, $post_id);
	}
	function get_the_category(){
		global $post;
		$cats_list =  $post->category;
		$cats_obj_list = array();
		
		foreach($cats_list as $cn){
			array_push($cats_obj_list, new Category($cn, $cn));	
		}
		return $cats_obj_list;
	}
	
	class Category{
		var $cat_ID;
		var $cat_name;
		
		function Category($id, $name){
			$this->cat_ID = $id;
			$this->cat_name = $name;
		}
	}
	
	function get_category_link($category_id){
		$url = get_option('url');
		return $url . "/?view=category&category=".$category_id;
	}
	
	//derecated
	function get_links_list($order = 'name', $deprecated = ''){}

	function edit_post_link(){}
	
	////////// Prev/Next links
	function posts_nav_link($sep=' &#8212; ', $prelabel='&laquo; Previous Page', $nxtlabel='Next Page &raquo;') {
        if ( !is_singular() ) {
			previous_posts_link($prelabel);
			echo preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $sep);
			next_posts_link($nxtlabel);
		}
	}

	
	// on singlepost pages
	function next_post_link($format='%link &raquo;', $link='%title', $in_same_cat = false, $excluded_categories = '') {
        adjacent_post_link($format, $link, $in_same_cat, $excluded_categories, false);
	}
	function previous_post_link($format='&laquo; %link', $link='%title', $in_same_cat = false, $excluded_categories = '') {
        adjacent_post_link($format, $link, $in_same_cat, $excluded_categories, true);
	}
	function adjacent_post_link($format, $link, $in_same_cat = false, $excluded_categories = '', $previous = true) {
        $post = get_adjacent_post($in_same_cat, $excluded_categories, $previous);
		if ( !$post )
                return;
        
		$title = $post->post_title;
		if ( empty($post->post_title) )
                $title = $previous ? __('Previous Post') : __('Next Post');
		
        $string = '<a href="'.get_permalink($post).'">';
		$link = str_replace('%title', $title, $link);
        $link = $string . $link . '</a>';
		$format = str_replace('%link', $link, $format);
        echo $format;
	}
	function get_adjacent_post($in_same_cat, $excluded_categories, $previous){
		global $cur_category;
		if(is_null($GLOBALS["post"])) return; 
		$cur_post_id = $GLOBALS["post"]->id();
		if($previous && $cur_post_id == 1) return;
		if($previous){
			$get_post_id = $cur_post_id - 1;
		}else{
			$get_post_id = $cur_post_id + 1;
		}
		
		if($in_same_cat){
			// TODO get next in cat
			//$elist = getCategoryEntryByCpid($get_post_id, $cur_category);
		}else{
			$elist = getEntryById($get_post_id);
		}
		if(!is_null($elist) && count($elist) > 0){
			return array_shift($elist);
		}
		return null;
	}
	
	// on multipost pages
	// OLDER
	function next_posts_link($label='Next Page &raquo;', $max_page=0){
		global $next_posts;
		if($next_posts){
			echo '<a href="';
			next_posts();
			echo '">'. preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $label) .'</a>';
		}
	}
	function next_posts(){
		echo get_next_posts_page_link();
	}
	function get_next_posts_page_link(){
		global $post_offset, $post_limit, $query_args;
		$new_offset = $post_offset + $post_limit;
		$url = get_option('url');
		$an_qargs = $query_args;
		
		$an_qargs["post_offset"] = $new_offset;
		$an_qargs["post_limit"] = $post_limit;
		
		$q = $url . "/?"; 

		foreach ($an_qargs as $k => $v) {
  	  		$q .= $k."=".$v."&";
		}
		if( substr($q, strlen($q)-1, 1) == '&' ){
			$q = substr($q, 0, strlen($q)-1);
		}
		return $q;
		
	}
	
	
	// NEWER
	function previous_posts_link($label='&laquo; Previous Page'){
		global $prev_posts;
		if($prev_posts){
			echo '<a href="';
			previous_posts();
			echo '">'. preg_replace('/&([^#])(?![a-z]{1,8};)/', '&#038;$1', $label) .'</a>';
		}
	}
	function previous_posts() {
        echo get_previous_posts_page_link();
	}
	function get_previous_posts_page_link(){
		global $post_offset, $post_limit, $query_args;
		$new_offset = $post_offset - $post_limit;
		if($new_offset < 0) $new_offset = 0;
		$url = get_option('url');
		$an_qargs = $query_args;
		
		$an_qargs["post_offset"] = $new_offset;
		$an_qargs["post_limit"] = $post_limit;
		
		$q = $url . "/?"; 

		foreach ($an_qargs as $k => $v) {
  	  		$q .= $k."=".$v."&";
		}
		if( substr($q, strlen($q)-1, 1) == '&' ){
			$q = substr($q, 0, strlen($q)-1);
		}
		return $q;
	}
	
	// TODO sometimes used in single
	function wp_link_pages(){
		if(is_single()){
			echo "<p>";
			previous_post_link();
			echo " ";
			next_post_link();
			echo "</p>";
		}
	}
	//deprecated
	function link_pages($before='<br />', $after='<br />', $next_or_number='number', $nextpagelink='next page', $previouspagelink='previous page', $pagelink='%', $more_file='') {
		$args = compact('before', 'after', 'next_or_number', 'nextpagelink', 'previouspagelink', 'pagelink', 'more_file');
		return wp_link_pages($args);
	}
	
	function comments_template(){}
	
	function antispambot(){
		// ,      !
	} 
	function wp_loginout(){}
	
	function get_calendar(){
		include_once('lib/calendar.php');
		show_calendar();
	}
	
	function wp_list_categories(){
		$list = get_list_categories();
		$url = get_option('url');
		echo "<ul>";
		for($i = 0; $i < count($list); $i++){
			echo '<li class="categories">';
			echo '<a href="' . $url . "/?view=category&category=" . urlencode($list[$i]) . '">';
			echo $list[$i];
			echo "</a>";
			echo '</li>';		
		}
		echo "</ul>";
	}
	function wp_list_cats(){ //DEPRECATED
		wp_list_categories();
	}
	
		
	// Blogroll
	function wp_list_bookmarks(){
		$fname = 'include/blogroll.php';
		if(file_exists($fname))	include_once($fname);
	}
	function get_links(){
		get_bookmarks();
	}
	function get_bookmarks(){
		wp_list_bookmarks();
	}
	// TagCloud
	function wp_tag_cloud(){
		$fname = 'include/tagcloud.php';
		if(file_exists($fname))	include_once($fname);
	}
	
	function register_sidebar(){}
	
	function the_author_posts_link($deprecated = '') {
		printf(	'Posts by %s' , get_the_author());
	}
	function get_the_author(){
		return get_option('authorname');
	}
	function get_author_posts_url(){}
		
	function the_author(){
		echo get_the_author();
	}
	function the_author_link(){}
	
	function comments_popup_link(){}
	
	function the_ID() {
        echo get_the_ID();
	}

	function get_the_ID() {
	 	global $post;
		return $post->id();
	}
	
	function the_title_attribute( $args = '', $echo = true ) {
        $title = get_the_title();
        if ( strlen($title) == 0 ) return;
        $title = str_replace('"', '',$title);  
		$title = str_replace("'", '',$title);
        if ( $echo )
                echo $title;
        else
                return $title;
	}
	
	function get_sidebar( $name = null ) {
		if ( isset($name) && file_exists( TEMPLATEPATH . "/sidebar-{$name}.php") ){
            load_template( TEMPLATEPATH . "/sidebar-{$name}.php");
		}elseif ( file_exists( TEMPLATEPATH . '/sidebar.php') ){
			load_template( TEMPLATEPATH . '/sidebar.php');
		}else{
            load_template( ABSPATH . 'default-theme/sidebar.php');
		}
	}
	
	function wp_footer(){}
	
	// DEPRECATED
	function get_settings($option) {
        return get_option($option);
	}
	
	function wp_meta(){}
	
	function wp_register(){}
	function single_post_title(){}
	
	function single_cat_title($prefix = '', $display = true ){
		global $cur_category;
		if ( $display ){
			echo $prefix.strip_tags($cur_category);
		}else{
			return strip_tags($cur_category);
		}
	}
	
	function single_tag_title(){}
	function single_month_title(){}
	
	function the_date_xml() {
        global $post;
        echo mysql2date('Y-m-d', $post->post_date);
	}
	
	function get_search_query() {
        // Originally this have to do something like:
		//return $_GET['s'];//
		// But it's not XSS safe
		return ""; // This is very XSS safe :)
	}
	function the_search_query() {
		echo get_search_query();
	}
	function timer_stop(){}
	function timer_start(){}
	
	function wp_enqueue_script(){}
	
	function get_day_link($year, $month, $day) {
        //global $wp_rewrite;
        if ( !$year )
                $year = gmdate('Y', time()+(0 * 3600));
        if ( !$month )
                $month = gmdate('m', time()+(0 * 3600));
        if ( !$day )
                $day = gmdate('j', time()+(0 * 3600));

        return get_option('home') . '/?m=' . $year . zeroise($month, 2) . zeroise($day, 2);
	}
	function zeroise($number,$threshold) { // function to add leading zeros when necessary
        return sprintf('%0'.$threshold.'s', $number);
	}

	
	
	/*
	 * //////////CLASSES HERE
	 */
	
	class Wpdb{
		function __get($prop_name){
			return;
		}
		function __set($prop_name, $prop_value){
			return true;
		}
		function __call($a1, $a2){
			return;	
		}
		
		function get_results($query = null, $output = OBJECT) {
			return array();
		}
	}
	
	function update_post_caches(){}
	
	function wp_specialchars( $text, $quotes = 0 ) {
        // Like htmlspecialchars except don't double-encode HTML entities
        $text = str_replace('&&', '&#038;&', $text);
        $text = str_replace('&&', '&#038;&', $text);
        $text = preg_replace('/&(?:$|([^#])(?![a-z1-4]{1,8};))/', '&#038;$1', $text);
        $text = str_replace('<', '&lt;', $text);
        $text = str_replace('>', '&gt;', $text);
        if ( 'double' === $quotes ) {
                $text = str_replace('"', '&quot;', $text);
        } elseif ( 'single' === $quotes ) {
                $text = str_replace("'", '&#039;', $text);
        } elseif ( $quotes ) {
                $text = str_replace('"', '&quot;', $text);
                $text = str_replace("'", '&#039;', $text);
        }
        return $text;
	}
	
	function setup_postdata(){}
	function wp_get_post_tags(){
		return array();
	}
	function comments_open(){}
	function get_currentuserinfo(){}
	function comments_rss_link(){}
	function get_the_tags(){
		return array();
	}
	function get_the_author_ID(){}
	function get_search_form(){}
	function get_num_queries(){}
	function register_sidebars(){}
	function register_sidebar_widget(){}
	function pings_open(){}
	function get_comment_link(){}
	function get_comment_author(){}
	function get_comment_text(){}
	
	function get_feed_link($feed = 'rss'){
		global $query_args;
		$url = get_option('url');
		$url .= "/?";
		foreach((array) $query_args as $qa=>$qv){
			$url .= $qa."=".$qv."&";
		}
		$url .= "viewtype=feed&feed=".$feed;
		return $url;
	}
	
	function attribute_escape($text) {
        $safe_text = wp_specialchars($text, true);
        return apply_filters('attribute_escape', $safe_text, $text);
	}
	// Escape single quotes, specialchar double quotes, and fix line endings.
	function js_escape($text) {
        $safe_text = wp_specialchars($text, 'double');
        $safe_text = preg_replace('/&#(x)?0*(?(1)27|39);?/i', "'", stripslashes($safe_text));
        $safe_text = preg_replace("/\r?\n/", "\\n", addslashes($safe_text));
        return apply_filters('js_escape', $safe_text, $text);
	}

	function sanitize_term_field($field, $value, $term_id, $taxonomy, $context) {
        if ( 'parent' == $field  || 'term_id' == $field || 'count' == $field || 'term_group' == $field ) {
                $value = (int) $value;
                if ( $value < 0 )
                        $value = 0;
        }

        if ( 'raw' == $context )
                return $value;

        if ( 'edit' == $context ) {
                $value = apply_filters("edit_term_$field", $value, $term_id, $taxonomy);
                $value = apply_filters("edit_${taxonomy}_$field", $value, $term_id);
                if ( 'description' == $field )
                        $value = format_to_edit($value);
                else
                        $value = attribute_escape($value);
        } else if ( 'db' == $context ) {
                $value = apply_filters("pre_term_$field", $value, $taxonomy);
                $value = apply_filters("pre_${taxonomy}_$field", $value);
                // Back compat filters
                if ( 'slug' == $field )
                        $value = apply_filters('pre_category_nicename', $value);

        } else if ( 'rss' == $context ) {
                $value = apply_filters("term_${field}_rss", $value, $taxonomy);
                $value = apply_filters("${taxonomy}_${field}_rss", $value);
        } else {
                // Use display filters by default.
                $value = apply_filters("term_$field", $value, $term_id, $taxonomy, $context);
                $value = apply_filters("${taxonomy}_$field", $value, $term_id, $context);
        }

        if ( 'attribute' == $context )
                $value = attribute_escape($value);
        else if ( 'js' == $context )
                $value = js_escape($value);

        return $value;
	}

	
	function get_post_custom(){
		return array();
	}

	function the_generator ( $type ) {
        echo apply_filters('the_generator',get_the_generator($type),$type) . "\n";
	}
	
	function get_the_generator ( $type ) {
        switch ($type) {
                case 'html':
                        $gen = '<meta name="generator" content="WordPress ' . get_bloginfo( 'version' ) . '">' . "\n";
                        break;
                case 'xhtml':
                        $gen = '<meta name="generator" content="WordPress ' . get_bloginfo( 'version' ) . '" />' . "\n";
                        break;
                case 'atom':
                        $gen = '<generator uri="http://wordpress.org/" version="' . get_bloginfo_rss( 'version' ) . '">WordPress</generator>';
                        break;
                case 'rss2':
                        $gen = '<generator>http://wordpress.org/?v=' . get_bloginfo_rss( 'version' ) . '</generator>';
                        break;
                case 'rdf':
                        $gen = '<admin:generatorAgent rdf:resource="http://wordpress.org/?v=' . get_bloginfo_rss( 'version' ) . '" />';
                        break;
                case 'comment':
                        $gen = '<!-- generator="WordPress/' . get_bloginfo( 'version' ) . '" -->';
                        break;
                case 'export':
                        $gen = '<!-- generator="WordPress/' . get_bloginfo_rss('version') . '" created="'. date('Y-m-d H:i') . '"-->';
                        break;
        }
        return apply_filters( "get_the_generator_{$type}", $gen, $type );
	}
	
	function get_lastpostmodified($timezone = 'server') {
        return get_lastpostdate($timezone);	
	}
	function get_lastpostdate($timezone = 'server') {
		$add_seconds_server = date('Z');
		$lastpostdate = getEntryBaseLastModified();      
        return apply_filters( 'get_lastpostdate', $lastpostdate, $timezone );
	}
	
	function get_post_comments_feed_link(){}
	function get_the_author_url(){}
	
	function get_post_modified_time( $d = 'U', $gmt = false ) { // returns timestamp
        global $post;
        if ( $gmt )
                $time = $post->post_modified_gmt;
        else
                $time = $post->post_modified;
        $time = mysql2date($d, $time);
        return apply_filters('get_the_modified_time', $time, $d, $gmt);
	}

	
?>